#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum ResolvedUdfParameterType {
    #[serde(rename = "F64")]
    F64,
    #[serde(rename = "I64")]
    I64,
    #[serde(rename = "STRING")]
    String,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl ResolvedUdfParameterType {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            ResolvedUdfParameterType::F64 => "F64",
            ResolvedUdfParameterType::I64 => "I64",
            ResolvedUdfParameterType::String => "STRING",
            ResolvedUdfParameterType::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for ResolvedUdfParameterType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for ResolvedUdfParameterType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for ResolvedUdfParameterType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<ResolvedUdfParameterType, conjure_object::plain::ParseEnumError> {
        match v {
            "F64" => Ok(ResolvedUdfParameterType::F64),
            "I64" => Ok(ResolvedUdfParameterType::I64),
            "STRING" => Ok(ResolvedUdfParameterType::String),
            v => v.parse().map(|v| ResolvedUdfParameterType::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for ResolvedUdfParameterType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<ResolvedUdfParameterType, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the ResolvedUdfParameterType enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
